// Generated by CoffeeScript 1.6.3
var Monitor, fs, libMonitor, md, moment, notifier, path, script, startTime, util,
  __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

moment = require('moment');

path = require('path');

util = require('util');

fs = require('fs');

Monitor = require('findr').Monitor;

notifier = require('./loggers').notifier;

startTime = moment();

if (script = process.env.SQ_SCRIPT) {
  md = require(path.resolve(script));
} else {
  notifier.error("no script specified");
  process.exit(1);
}

if (fs.existsSync('lib')) {
  libMonitor = new Monitor('lib Monitor', path.resolve('lib'));
  libMonitor.on('changed', function(f) {
    if (__indexOf.call(Object.keys(require.cache), f) >= 0) {
      return process.exit(0);
    }
  });
  libMonitor.start();
}

process.on('uncaughtException', function(err) {
  notifier.error(err.toString(), {
    title: "Exception"
  });
  if (moment().diff(startTime, 'cents') < 500) {
    notifier.error("exception loop, shutting down script");
    return process.exit(1);
  } else {
    notifier.info("restart script");
    return process.exit(0);
  }
});
